//
//  P4SpecDescription.h
//  P4ObjectLayer
//
//  Created by Michael Bishop on 9/19/10.
//  Copyright 2010 Numerical Garden, LLC. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@class P4SpecFieldDescription;

@interface P4SpecDescription : NSObject {
    void *                  _specCPP;
    int                     _identifierCode;
    NSMutableDictionary *   _parsedValues;
}

+(P4SpecDescription*)specDescriptionWithEncodedDefinition:(NSString*)specdef;
+(P4SpecDescription*)specDescriptionWithSpecDefProperties:(NSDictionary*)properties;

-(id)initWithSpecDefString:(NSString*)specdef;
-(id)initWithSpecDefProperties:(NSDictionary*)properties;

-(int)fieldCount;

-(NSSet*)allCodes;
-(NSSet*)allTags;

-(int)identifierCode;

-(P4SpecFieldDescription*)fieldForCode:(int)code;
-(P4SpecFieldDescription*)fieldForTag:(NSString*)name;

-(NSString*)encodedDefinition;

-(NSString*)formFromSpecProperties:(NSDictionary*)rawData;

@end

@interface P4SpecFieldDescription : NSObject {
    P4SpecDescription * _specDescription;
    int                 _code;
}

-(BOOL)isDate;
-(BOOL)isIdentifier;
-(BOOL)isList;
-(BOOL)isAlwaysSet;
-(BOOL)isReadOnly;

// Array of valuetypes where each item is an array of the possible values, all strings
// So, the encoded spec value string "a/b/c,d/e/f" becomes
// [["a","b","c"],["d","e","f"]] <- what this method returns

-(NSArray*)values;


@property (readonly, nonatomic) NSString * tag;
@property (readonly, nonatomic) int code;

@end

