/*
 *  P4TypeConversions.h
 *  SCMMenuExtra
 *
 *  Created by Michael Bishop on 1/29/10.
 *  Copyright 2010 Perforce Software. All rights reserved.
 *
 */
#ifndef P4TypeConversions_h
#define P4TypeConversions_h

class StrRef;
class StrBuf;
class StrPtr;
class StrDict;
class Error;

// Utility methods to convert Perforce objects to Cocoa objects

@interface NSString (P4TypeConversions)

-(StrRef)strRef;
-(StrBuf)strBuf;

+(NSString*)stringWithStrPtr:(const StrPtr&)strptr;

@end

@interface NSDictionary (P4TypeConversions)

+(NSDictionary*)dictionaryWithStrDict:(const StrDict&)strDict;

@end

@interface NSError (P4TypeConversions)

+(NSError*)errorWithP4Error:(const Error&)error;
-(id)initWithP4Error:(const Error*)error;

@end


#endif // P4TypeConversions_h
