//
//  SCMSubmitDialog.h
//  SCMMenuExtra
//
//  Created by Michael Bishop on 5/12/11.
//  Copyright 2011 Numerical Garden LLC. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@protocol SCMSubmitter <NSObject>

-(void)submitFile:(NSString*)filepath
  withDescription:(NSString*)description
  completionBlock:(void(^)(NSError*))completion;

@end


@interface SCMSubmitDialog : NSWindowController {
@private
    
    IBOutlet NSButton * submitButton;
    IBOutlet NSTextField * promptLabel;
    IBOutlet NSTextView *descriptionTextView;
    
    NSString *              filepath;
    id<SCMSubmitter>        submitter;
}

@property (nonatomic, readwrite, copy) NSString * filepath;
@property (nonatomic, readonly) NSString * filename;
@property (nonatomic, readwrite, assign) id<SCMSubmitter> submitter;

-(IBAction)submit:(id)sender;

@end
