//
//  P4Client.h
//  MBMenuExtra
//
//  Created by Michael Bishop on 12/18/09.
//  Copyright 2009 Perforce Software. All rights reserved.
//

#import "P4Spec.h"

@class P4Response;
@class P4Mapper;

@interface P4Client : P4Spec {
}

@property (nonatomic, readonly) NSString * root;
@property (nonatomic, readonly) NSArray * altRoots;
@property (nonatomic, readonly) NSArray * roots; // Both "root" + "altRoots" in order

@property (nonatomic, readonly) NSArray * view; // Array of strings containing the map rows

-(BOOL)runArguments:(NSArray*)args
        withContext:(NSDictionary*)context
    completionBlock:(void(^)(P4Response*))completion;

-(P4Response*)runArguments:(NSArray*)args
               withContext:(NSDictionary*)context
                   content:(NSString*)content;

-(P4Mapper*)viewMapper;

-(NSString*)clientPathForLocalFilePath:(NSString*)localFilePath root:(NSString**)returnedRoot;
-(BOOL)viewContainsClientPath:(NSString*)clientPath;


@end
