//
//  P4Connection.h
//  P4ObjectLayer
//
//  Created by Michael Bishop on 4/8/11.
//  Copyright 2011 Numerical Garden, LLC. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "P4RawConnection.h"

@class P4Port;
@class P4Response;


@interface P4Connection : NSObject {
@private
    NSString *              _portstring;
    NSString *              _username;
    BOOL                    _needsNewPassword;
    BOOL                    _requiresTickets;
}

+(P4Connection*)connectionWithPortString:(NSString*)portstring
                                    user:(NSString*)username;

-(P4Response*)runArguments:(NSArray*)arguments
               withContext:(NSDictionary*)context
                   content:(NSString*)content;

-(BOOL)runArguments:(NSArray*)arguments
        withContext:(NSDictionary*)context
        updateBlock:(UpdateBlock)update
    completionBlock:(void(^)(P4Response*))completion;

-(BOOL)runArguments:(NSArray*)arguments
        withContext:(NSDictionary*)context
        content:(NSString*)content
        updateBlock:(UpdateBlock)update
    completionBlock:(void(^)(P4Response*))completion;

@property (nonatomic,readonly) NSString *   portString;
@property (nonatomic,readonly) P4Port *     p4port;
@property (nonatomic,readonly) NSString *   username;
@property (nonatomic,readonly) BOOL         needsNewPassword;
@end
