//
//  P4ConnectionPool.h
//  MBMenuExtra
//
//  Created by Michael Bishop on 1/7/10.
//  Copyright 2010 Perforce Software. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "P4RawConnection.h"

@class P4Response;

@interface P4ConnectionPool : NSObject {

    NSMutableDictionary * _connections;    
    NSTimeInterval    networkDelay;
}

+(P4ConnectionPool*)sharedPool;

-(BOOL)runArgument:(NSString*)argument
            onPort:(NSString*)p4port
       withContext:(NSDictionary*)context
       updateBlock:(UpdateBlock)update
   completionBlock:(void(^)(P4Response*))completion;

-(BOOL)runArguments:(NSArray*)arguments
             onPort:(NSString*)p4port
        withContext:(NSDictionary*)context
        updateBlock:(UpdateBlock)update
    completionBlock:(void(^)(P4Response*))completion;

-(BOOL)runArguments:(NSArray*)arguments
             onPort:(NSString*)p4port
        withContext:(NSDictionary*)context
            content:(NSString*)content
        updateBlock:(UpdateBlock)update
    completionBlock:(void(^)(P4Response*))completion;


// Synchronous.
-(P4Response*)runArguments:(NSArray*)arguments
                    onPort:(NSString*)p4port
               withContext:(NSDictionary*)context
                   content:(NSString*)content;

@property (readwrite) NSTimeInterval networkDelay;

@end

