//
//  P4FilePath.h
//  P4Menu
//
//  Created by Michael Bishop on 1/16/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

typedef enum P4FilePathType {
    SERVER,
    LOCAL
} P4FilePathType;

@interface P4FilePath : NSObject {
    P4FilePathType _type;
    NSString * _path;
    NSString * _revision;
}

+(id)filePathParsedFromString:(NSString*)string;

+(id)filePathWithType:(P4FilePathType)type path:(NSString*)path revision:(NSString*)revision;

-(id)initWithType:(P4FilePathType)type path:(NSString*)path revision:(NSString*)revision;

@property (nonatomic, readonly, assign) P4FilePathType type;
@property (nonatomic, readonly, copy) NSString * path;
@property (nonatomic, readonly, copy) NSString * revision;

@property (nonatomic, readonly) NSString * formattedPath;
@property (nonatomic, readonly) NSString * formattedString;

@end


@interface P4MutableFilePath : P4FilePath

@property (nonatomic, readwrite, assign) P4FilePathType type;
@property (nonatomic, readwrite, copy) NSString * path;
@property (nonatomic, readwrite, copy) NSString * revision;

@end