//
//  P4ObjectLayer_AppDelegate.h
//  P4ObjectLayer
//
//  Created by Michael Bishop on 7/20/10.
//  Copyright Numerical Garden, LLC 2010 . All rights reserved.
//

#import <Cocoa/Cocoa.h>

@class P4Spec;
@class P4Port;

@interface P4ObjectLayer_AppDelegate : NSObject 
{
    NSWindow *window;
    
    NSPersistentStoreCoordinator *persistentStoreCoordinator;
    NSManagedObjectModel *managedObjectModel;
    NSManagedObjectContext *managedObjectContext;
    
    P4Port * port;
    NSArray * clients;
    NSArray * users;
    NSArray * changes;
    NSArray * jobs;
}

@property (nonatomic, retain) IBOutlet NSWindow *window;

@property (nonatomic, retain, readonly) NSPersistentStoreCoordinator *persistentStoreCoordinator;
@property (nonatomic, retain, readonly) NSManagedObjectModel *managedObjectModel;
@property (nonatomic, retain, readonly) NSManagedObjectContext *managedObjectContext;

@property (nonatomic, copy) NSArray * clients;
@property (nonatomic, copy) NSArray * users;
@property (nonatomic, copy) NSArray * changes;
@property (nonatomic, copy) NSArray * jobs;
@property (nonatomic, retain) P4Port * port;

- (IBAction)saveAction:(id)sender;
- (IBAction)refresh:(id)sender;

@end
