//
//  P4SpecEntityDescriptionAdditions.h
//  P4ObjectLayer
//
//  Created by Michael Bishop on 9/8/10.
//  Copyright 2010 Numerical Garden, LLC. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@class P4SpecManager;
@class P4SpecDescription;

@interface NSEntityDescription (P4SpecEntityDescriptionAdditions)

-(P4SpecManager*)manager;

-(NSString*)identifierPropertyName;

-(NSString*)lastAccessedPropertyName;

-(NSArray*)inverseFetchedProperties;
-(void)setInverseFetchedProperties:(NSArray*)fetchedProperties;

-(NSDictionary*)specKeyToMOKeyMapping;

-(NSDictionary*)fetchedPropertyDescriptions;
-(void)setFetchedPropertyDescriptions:(NSDictionary*)fetchedProperties;

-(NSString*)type;

-(NSSet*)allMappedSpecKeys;

-(NSDictionary*)summaryPropertyDescriptions;

-(NSString*)specTagForPropertyName:(NSString*)propertyName;

-(P4SpecDescription*)specDescription;

@end
